<template>
    <div class="contenedor">
      <div :id="name_id" :style="filtros.styleObject"></div>
    </div>
</template>

<script>

import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";
import am4themes_material from "@amcharts/amcharts4/themes/material";


export default {
    name: "GraficaBarrasHorizontalSupMto",
    props: {
        name_id: String
    },

    data() {
        return {
            chart: null,
            filtros: {
                        value : 0,
                        target : 0,
                        categoria : "Categoria",
                        name_id: "objeto2",
                        datos : ["",""],
                        styleObject: {
                            width: "50%",
                            height: "110px",
                            margin: "auto"
                        },
                        rColores: [],
                        rCalf: [],
            },
        };
    }, 
    methods: {
        initChartG(){
            const self = this;
            am4core.useTheme(am4themes_animated);

            /* Create chart instance */
            var chart = am4core.create(this.filtros.name_id,am4charts.XYChart);
            chart.logo.hidden = true;
            chart.paddingRight = 25;

            /* Add data */
            chart.data = [
                {
                    "category": "",
                    "value": this.filtros.value,
                    "target": this.filtros.target
                }
            ];

            /* Create axes */
            var categoryAxis = chart.yAxes.push(new am4charts.CategoryAxis());
            categoryAxis.dataFields.category = "category";
            categoryAxis.renderer.minGridDistance = 1;
            categoryAxis.renderer.grid.template.disabled = true;

            var valueAxis = chart.xAxes.push(new am4charts.ValueAxis());
            valueAxis.renderer.minGridDistance = 30;
            valueAxis.renderer.grid.template.disabled = true;
            valueAxis.min = 0;
            valueAxis.max = this.filtros.target;
            valueAxis.strictMinMax = true;
            valueAxis.numberFormatter.numberFormat = "####";
            valueAxis.renderer.baseGrid.disabled = false;
            valueAxis.fontSize =10;

            valueAxis.title.text =  this.filtros.value+" "+this.filtros.datos[0] +"\n"+
            this.filtros.target+" "+this.filtros.datos[1];//"texto1";
            valueAxis.title.fontWeight="bold";

            var start , end;
            if(this.filtros.rCalf.length>0){
                start = this.filtros.rCalf[0].split(",")[0];
                var startCalculado =(( this.filtros.target) / 100 *start);
                for (var i = 0; i < this.filtros.rCalf.length; ++i) {
                
                    end = this.filtros.rCalf[i].split(",")[1];
                    var range = valueAxis.axisRanges.create();
                    var endCalculado =(( this.filtros.target) / 100 *end);
                    range.value = startCalculado;
                    range.endValue = endCalculado;
                    range.axisFill.fill = am4core.color(this.filtros.rColores[i]);
                    range.axisFill.fillOpacity = 1;
                    range.label.disabled = true;
                    range.grid.disabled = true;
                    startCalculado=endCalculado;
                }
            }
/*
            var start = 0, end = this.filtros.rCalf;
            for (var i = 0; i < this.filtros.rColores.length; ++i) {
                var range = valueAxis.axisRanges.create();
                var endCalculado =(( this.filtros.target) / 100*end[i] )
                range.value = start;
                range.endValue = endCalculado;
                range.axisFill.fill = am4core.color(this.filtros.rColores[i]);
                range.axisFill.fillOpacity = 1;
                range.label.disabled = true;
                range.grid.disabled = true;
                start =endCalculado;
            }
            */
/*
            var gradient = new am4core.LinearGradient();
            for (var i = 0; i < 3; ++i) {
                // add each color that makes up the gradient
                gradient.addColor(am4core.color(colors[i]));
            }
            var range = valueAxis.axisRanges.create();
            range.value = 0;
            range.endValue =  this.target;
            range.axisFill.fill = gradient;
            range.axisFill.fillOpacity = 0.8;
            range.label.disabled = true;
            range.grid.disabled = true;
*/

            var series = chart.series.push(new am4charts.ColumnSeries());
            series.dataFields.valueX = "value";
            series.dataFields.categoryY = "category";
            series.columns.template.fill = am4core.color("#000");
            series.columns.template.stroke = am4core.color("#000");
            series.columns.template.strokeWidth = 1;
            series.columns.template.strokeOpacity = 0.5;
            series.columns.template.height = am4core.percent(30);
            series.tooltipText = "{value}"

            chart.cursor = new am4charts.XYCursor()
            chart.cursor.lineX.disabled = true;
            chart.cursor.lineY.disabled = true;

            valueAxis.cursorTooltipEnabled = false;
            chart.arrangeTooltips = true;


            this.chart = chart;
        },
            
        setValores(filtros) {

            this.filtros=filtros;
            this.initChartG();
        },

    },
    mounted() {
       this.filtros.name_id = this.name_id ;
    },
    beforeDestroy(){
        if(this.chart!=null) {
            this.chart.dispose(); 
        }
    }
    
}
</script>

<style>

</style>